/*============================================================================
//	aPCI-P54̒`
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	{{[h͂`ohbQP𓋍ڂĂ܂
//
//==========================================================================*/
#if !defined(_APCI54_H)
#define _APCI54_H

#ifndef _TYPEDEF_H
	#include "typedef.h"
#endif

#ifndef _APCISRVS_H
	#include "apcisrvs.h"
#endif

#ifndef _APCICTRL_H
	#include "apcictrl.h"
#endif

/*==========================================*/
/*	aPCI-P54 card's relative port address	*/
/*==========================================*/
#define	APCI54_PORT_A	0
#define	APCI54_PORT_B	1
#define	APCI54_PORT_C	2
#define	APCI54_PORT_D	3
#define	APCI54_PORT_E	4
#define	APCI54_PORT_F	5
#define	APCI54_PORT_DIR	6

/*==================================*/
/*	aPCI-P54 card's I/O directions	*/
/*==================================*/
#define APCI54_DIR_A_OUTPUT		(0 << 0)
#define APCI54_DIR_A_INPUT		(1 << 0)
#define APCI54_DIR_B_OUTPUT		(0 << 1)
#define APCI54_DIR_B_INPUT		(1 << 1)
#define APCI54_DIR_C_OUTPUT		(0 << 2)
#define APCI54_DIR_C_INPUT		(1 << 2)
#define APCI54_DIR_D_OUTPUT		(0 << 3)
#define APCI54_DIR_D_INPUT		(1 << 3)
#define APCI54_DIR_E_OUTPUT		(0 << 4)
#define APCI54_DIR_E_INPUT		(1 << 4)
#define APCI54_DIR_F_OUTPUT		(0 << 5)
#define APCI54_DIR_F_INPUT		(1 << 5)

/*==================*/
/*	Miscellaneous	*/
/*==================*/
#define	APCI54_MAX_SLOTS	16			/* Maximum number of slots */
#define APCI54_MAX_PORTS	6			/* Maximum number of user ports */

/*==============*/
/*	Device ID	*/
/*==============*/
#define	APCI54_BOARD_ID		0x9054		/* pci bus device id */
#define	APCI54_VENDOR_ID	0x136c		/* pci bus vendor id */
										/* our device id */
#define	APCI54_DEVICE_ID	( ( DWORD )APCI54_BOARD_ID\
							| ( ( DWORD )APCI54_VENDOR_ID << 16 ) )

#endif
