/*============================================================================
//	apci54s.h
//
//	aPCI-P54
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//==========================================================================*/
#pragma once

#include <windows.h>
#include "Apci54w.h"

namespace SampleP54 {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// Form1 ̊Tv
	///
	/// x: ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^ R[hǉ܂
			//
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}

	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container ^components;

		static Apci54w* P54w;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			this->SuspendLayout();
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(292, 266);
			this->Name = L"Form1";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"aPCI-P54 Sample";
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			this->ResumeLayout(false);

		}
#pragma endregion
		private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e) {
			short wLogSlot;				/* ޲̘_ۯĔԍi[ */
			Apci54w::Resource* ri;		/* ؿ */
			int dwDllVer, dwDrvVer;
			int dwSwVal;				/* ۰ذ̒l */
			int dwDirections;			/* ިڸ */
			Byte cbDat;
			bool bResult;				/*  */
			String^ szBuf;
			int i;

			P54w = new Apci54w;
			ri   = new Apci54w::Resource;

			// 
			ri->dwNumMemWindows = 0;
			for (i=0; i<Apci54w::MAX_MEM; i++) {
				ri->dwMemBase[i]   = 0;
				ri->dwMemLength[i] = 0;
				ri->dwMemAttrib[i] = 0;
			}
			ri->dwNumIOPorts = 0;
			for (i=0; i<Apci54w::MAX_IO; i++) {
				ri->dwIOPortBase[i]   = 0;
				ri->dwIOPortLength[i] = 0;
			}
			ri->dwNumIRQs = 0;
			for (i=0; i<Apci54w::MAX_IRQ; i++) {
				ri->dwIRQRegisters[i] = 0;
				ri->dwIRQAttrib[i]    = 0;
			}
			ri->dwNumDMAs = 0;
			for (i=0; i<Apci54w::MAX_DMA; i++) {
				ri->dwDMALst[i]    = 0;
				ri->dwDMAAttrib[i] = 0;
			}
			for (i=0; i<Apci54w::MAX_RSV; i++)
				ri->dwReserved1[i] = 0;

			/*-------------------------------------------------
			// ްޮݔԍ\
			// aPCI-P54 DLL,ײްްޮݔԍ擾
			//-----------------------------------------------*/
			if (P54w->GetVersion(&dwDllVer, &dwDrvVer) == false) {
				ErrorMessage(Apci54w::SLOT_AUTO);
				return;
			}
			szBuf = String::Concat("Version\n",
									String::Format("DLL: 0x{0:x8}\n", dwDllVer),
									String::Format("DRV: 0x{0:x8}",   dwDrvVer));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// aPCI-P54̎gp錾
			//-----------------------------------------------*/
			wLogSlot = Apci54w::SLOT_AUTO;			/* gp޲T܂B*/
			bResult = P54w->Create(&wLogSlot);		/* ꍇA̎޲̘_ۯĔԍi[܂B*/
			if (bResult == false) {					/* ޲܂B*/
				ErrorMessage(Apci54w::SLOT_AUTO);
				return;
			}
			szBuf = String::Concat("Created\n\n",
									String::Format("LogSlot: {0}", wLogSlot));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// ؿ۰ذ̒l擾
			//-----------------------------------------------*/
			if (P54w->GetResource(wLogSlot, ri) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			if (P54w->GetSwitchValue(wLogSlot, &dwSwVal) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Concat("Resource\n",
									String::Format("IO Address: {0:x4}h - {1:x4}h\n",
													ri->dwIOPortBase[0],
													ri->dwIOPortBase[0] + ri->dwIOPortLength[0] - 1),
									String::Format("Switch    : {0:x}h", dwSwVal));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// Port A ިڸ݂o͂ɐݒ肷
			//-----------------------------------------------*/
			if (P54w->GetDirections(wLogSlot, &dwDirections) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			dwDirections = ~Apci54w::DIR_A_INPUT & dwDirections;	/* A Port ޯĂo͂ɕύX */
			if (P54w->SetDirections(wLogSlot, dwDirections) == false){
				ErrorMessage(wLogSlot);
				return;
			}
			ResultMessage("Port A ̃fBNVo͂ɕύX");
			/*-------------------------------------------------
			// Port A ɔCӂްo
			//-----------------------------------------------*/
			cbDat = 0xaa;
			if (P54w->OutPort(wLogSlot, Apci54w::PORT_A, cbDat) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Concat("Port A փf[^o\n",
									String::Format("Port A Out Data: {0:x2}h", cbDat));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// Port B ިڸ݂͂ɐݒ
			//-----------------------------------------------*/
			if (P54w->GetDirections(wLogSlot, &dwDirections) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			dwDirections = Apci54w::DIR_B_INPUT | dwDirections;	/* B Port ޯĂ͂ɕύX */
			if (P54w->SetDirections(wLogSlot, dwDirections) == false) {
				ErrorMessage(wLogSlot);
			return;
			}
			ResultMessage("Port B ̃fBNV͂ɕύX");
			/*-------------------------------------------------
			// Port B ްǂݍ
			//-----------------------------------------------*/
			cbDat = 0x00;
			if (P54w->InPort(wLogSlot, Apci54w::PORT_B, &cbDat) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Concat("Port B f[^\n",
									String::Format("Port B In Data: {0:x2}h", cbDat));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// aPCI-P54̎gpJ
			//-----------------------------------------------*/
			if (P54w->Close(wLogSlot) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			ResultMessage("Closed");
			this->Close();
		}

		/*============================================================================
		// ʂ\
		//==========================================================================*/
		private: void ResultMessage(String^ pszbuf)
		{
			MessageBox::Show(pszbuf, this->Text,
								MessageBoxButtons::OK, MessageBoxIcon::Information);
		}

		/*============================================================================
		// װүނ\
		//==========================================================================*/
		private: void ErrorMessage(short wLogSlot)
		{
			int dwRes = P54w->GetLastError(wLogSlot);
			String^ szbuf;

			switch (dwRes) {
				case Apci54w::ERR_WRAPDLL:
				case Apci54w::ERR_SYSTEM:
					dwRes = System::Runtime::InteropServices::Marshal::GetLastWin32Error();
					szbuf = String::Concat("System error\n\n",
											String::Format("Error code: 0x{0:x8}", dwRes));
					break;
				default:
					szbuf = String::Concat("aPCI-P54 error\n\n",
											String::Format("Error code: 0x{0:x8}", dwRes));
					break;
			}
			MessageBox::Show(szbuf, "aPCI-P54 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Stop);
		}

	};
}

