/*****************************************************************************/
/*	apci54w.h																 */
/*																			 */
/*	aPCI-P54															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*****************************************************************************/

#ifndef __APCI54W_H__
#define __APCI54W_H__

#include "apci54.h"

#ifdef __cplusplus
extern "C"{
#endif

#define APCI54_DLL_NAME		_T("apci54.dll")	/* DLL */
#define APCI54_ERR_WRAPDLL	((DWORD)-1)			/* ׯ߰֐װ */

BOOL Apci54wDllOpen();							/* DLL ۰ */
BOOL Apci54wDllClose();							/* DLL ۰ */
BOOL Apci54wGetVersion(PDWORD pdwDllVersion, PDWORD pdwDriverVersion);	/* aPCI-P54 DLL,ײންޮݔԍ擾 */
BOOL Apci54wCreate(PWORD pwLogSlot);			/* CӂaPCI-P54̎gp錾 */
BOOL Apci54wClose(WORD wLogSlot);				/* CӂaPCI-P54̎gpJ */
BOOL Apci54wGetResource(WORD wLogSlot, PAPCI54R pResInfo);				/* ؿ擾 */
BOOL Apci54wInPort(WORD wLogSlot, DWORD dwLogPort, PBYTE pbInValue);	/* Cӂ߰Ăް */
BOOL Apci54wOutPort(WORD wLogSlot, DWORD dwLogPort, BYTE bOutValue);	/* Cӂ߰Ăްo */
DWORD Apci54wGetLastError(WORD wLogSlot);								/* aPCI-P54̴װ */
BOOL Apci54wGetSwitchValue(WORD wLogSlot, PDWORD pdwSwitchValue);		/* ۰ذ̒l擾 */
BOOL Apci54wGetDirections(WORD wLogSlot, PDWORD pdwDirections);			/* ިڸ݂̏Ԃ擾 */
BOOL Apci54wSetDirections(WORD wLogSlot, DWORD dwDirections);			/* ިڸ݂ */

#ifdef __cplusplus
}
#endif

#endif /* __APCI54W_H__ */
