/*============================================================================
//	apci54s.cs
//
//	aPCI-P54
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//==========================================================================*/

//=========================================================================
// rh IvV̐ݒ菇܂B
//
// 1.vWFNg [vpeB] y[WJ܂B
// 2.[rh] vpeB y[WNbN܂B
// 3.[AZ[t R[h̋] `FbN {bNXIɂ܂B
//=========================================================================

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SampleP54
{
    public partial class Apci54s : Form
    {
		static Apci54w P54w;

        public Apci54s()
        {
            InitializeComponent();
        }

        private unsafe void Apci54s_Load(object sender, EventArgs e)
        {
			short wLogSlot;				/* ޲̘_ۯĔԍi[ */
			Apci54w.Resource ri;		/* ؿ */
			int dwDllVer, dwDrvVer;
			int dwSwVal;				/* ۰ذ̒l */
			int dwDirections;			/* ިڸ */
			Byte cbDat;
			bool bResult;				/*  */
			String szBuf;
			int i;

			P54w = new Apci54w();
			ri   = new Apci54w.Resource();
			ri.dwMemBase		= new int[Apci54w.MAX_MEM];
			ri.dwMemLength		= new int[Apci54w.MAX_MEM];
			ri.dwMemAttrib		= new int[Apci54w.MAX_MEM];
			ri.dwIOPortBase		= new int[Apci54w.MAX_IO];
			ri.dwIOPortLength	= new int[Apci54w.MAX_IO];
			ri.dwIRQRegisters	= new int[Apci54w.MAX_IRQ];
			ri.dwIRQAttrib		= new int[Apci54w.MAX_IRQ];
			ri.dwDMALst			= new int[Apci54w.MAX_DMA];
			ri.dwDMAAttrib		= new int[Apci54w.MAX_DMA];
			ri.dwReserved1		= new int[Apci54w.MAX_RSV];

			// 
			ri.dwNumMemWindows = 0;
			for (i=0; i<Apci54w.MAX_MEM; i++) {
				ri.dwMemBase[i]   = 0;
				ri.dwMemLength[i] = 0;
				ri.dwMemAttrib[i] = 0;
			}
			ri.dwNumIOPorts = 0;
			for (i=0; i<Apci54w.MAX_IO; i++) {
				ri.dwIOPortBase[i]   = 0;
				ri.dwIOPortLength[i] = 0;
			}
			ri.dwNumIRQs = 0;
			for (i=0; i<Apci54w.MAX_IRQ; i++) {
				ri.dwIRQRegisters[i] = 0;
				ri.dwIRQAttrib[i]    = 0;
			}
			ri.dwNumDMAs = 0;
			for (i=0; i<Apci54w.MAX_DMA; i++) {
				ri.dwDMALst[i]    = 0;
				ri.dwDMAAttrib[i] = 0;
			}
			for (i=0; i<Apci54w.MAX_RSV; i++)
				ri.dwReserved1[i] = 0;

			/*-------------------------------------------------
			// ްޮݔԍ\
			// aPCI-P54 DLL,ײްްޮݔԍ擾
			//-----------------------------------------------*/
			if (P54w.GetVersion(&dwDllVer, &dwDrvVer) == false) {
				ErrorMessage(Apci54w.SLOT_AUTO);
				return;
			}
			szBuf = String.Concat("Version\n",
									String.Format("DLL: 0x{0:x8}\n", dwDllVer),
									String.Format("DRV: 0x{0:x8}",   dwDrvVer));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// aPCI-P54̎gp錾
			//-----------------------------------------------*/
			wLogSlot = Apci54w.SLOT_AUTO;			/* gp޲T܂B*/
			bResult = P54w.Create(&wLogSlot);		/* ꍇA̎޲̘_ۯĔԍi[܂B*/
			if (bResult == false) {					/* ޲܂B*/
				ErrorMessage(Apci54w.SLOT_AUTO);
				return;
			}
			szBuf = String.Concat("Created\n\n",
									String.Format("LogSlot: {0}", wLogSlot));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// ؿ۰ذ̒l擾
			//-----------------------------------------------*/
			if (P54w.GetResource(wLogSlot, ref ri) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			if (P54w.GetSwitchValue(wLogSlot, &dwSwVal) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String.Concat("Resource\n",
									String.Format("IO Address: {0:x4}h - {1:x4}h\n",
													ri.dwIOPortBase[0],
													ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1),
									String.Format("Switch    : {0:x}h", dwSwVal));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// Port A ިڸ݂o͂ɐݒ肷
			//-----------------------------------------------*/
			if (P54w.GetDirections(wLogSlot, &dwDirections) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			dwDirections = ~Apci54w.DIR_A_INPUT & dwDirections;	/* A Port ޯĂo͂ɕύX */
			if (P54w.SetDirections(wLogSlot, dwDirections) == false){
				ErrorMessage(wLogSlot);
				return;
			}
			ResultMessage("Port A ̃fBNVo͂ɕύX");
			/*-------------------------------------------------
			// Port A ɔCӂްo
			//-----------------------------------------------*/
			cbDat = 0xaa;
			if (P54w.OutPort(wLogSlot, Apci54w.PORT_A, cbDat) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String.Concat("Port A փf[^o\n",
									String.Format("Port A Out Data: {0:x2}h", cbDat));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// Port B ިڸ݂͂ɐݒ
			//-----------------------------------------------*/
			if (P54w.GetDirections(wLogSlot, &dwDirections) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			dwDirections = Apci54w.DIR_B_INPUT | dwDirections;	/* B Port ޯĂ͂ɕύX */
			if (P54w.SetDirections(wLogSlot, dwDirections) == false) {
				ErrorMessage(wLogSlot);
			return;
			}
			ResultMessage("Port B ̃fBNV͂ɕύX");
			/*-------------------------------------------------
			// Port B ްǂݍ
			//-----------------------------------------------*/
			cbDat = 0x00;
			if (P54w.InPort(wLogSlot, Apci54w.PORT_B, &cbDat) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String.Concat("Port B f[^\n",
									String.Format("Port B In Data: {0:x2}h", cbDat));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// aPCI-P54̎gpJ
			//-----------------------------------------------*/
			if (P54w.Close(wLogSlot) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			ResultMessage("Closed");
			this.Close();
        }

		/*============================================================================
		// ʂ\
		//===========================================================================*/
		private void ResultMessage(string buf)
		{
			MessageBox.Show(buf, this.Text, 
							MessageBoxButtons.OK, MessageBoxIcon.Information);
		}

		/*============================================================================
		// װүނ\
		//===========================================================================*/
		private void ErrorMessage(short wLogSlot)
		{
			int dwRes = P54w.GetLastError(wLogSlot);
			string buf;

			switch (dwRes)
			{
				case Apci54w.ERR_WRAPDLL:
				case Apci54w.ERR_SYSTEM:
					dwRes = System.Runtime.InteropServices.Marshal.GetLastWin32Error();
					buf = String.Concat("System error\n\n", 
						String.Format("Error code: 0x{0:x8}", dwRes));
					break;

				default:
					buf = String.Concat("aPCI-P54 error\n\n",
						String.Format("Error code: 0x{0:x8}", dwRes));
					break;
			}
			MessageBox.Show(buf, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Stop);
		}

    }
}