'============================================================================
'   aPCI-P54
'
'   Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'
'============================================================================

Option Strict Off
Option Explicit On 

Imports System
Imports System.Runtime.InteropServices

Public Class Apci54w

    Private mErrWradll As Integer = SUCCESS   ' bp[֐G[

    '-------------------------------------
    ' װޒ萔
    '-------------------------------------
    Public Const SUCCESS As Integer = 0                 ' ُȂ
    Public Const ERR_SYSTEM As Integer = 1              ' GetLastError sĂ
    Public Const ERR_NO_DEVICE As Integer = 2           ' gp\ȃfoCXȂ
    Public Const ERR_IN_USE As Integer = 3              ' w肳ꂽۯĂ͎gp
    Public Const ERR_INVALID_SLOT As Integer = 4        ' ȁi_jۯĔԍ
    Public Const ERR_RESOURCE As Integer = 5            ' \[XG[
    Public Const ERR_INVALID_PORT As Integer = 6        ' ȃ|[gԍ
    Public Const ERR_INVALID_ARGUMENT As Integer = 7    ' Ȉ
    Public Const ERR_NO_CREATE As Integer = 8           ' foCXNGCgĂ܂
    Public Const ERR_WRAPDLL As Integer = -1            ' bp[֐G[
    '-------------------------------------
    ' _߰
    '-------------------------------------
    Public Const PORT_A As Integer = 0
    Public Const PORT_B As Integer = 1
    Public Const PORT_C As Integer = 2
    Public Const PORT_D As Integer = 3
    Public Const PORT_E As Integer = 4
    Public Const PORT_F As Integer = 5
    '-------------------------------------
    ' Direction
    '-------------------------------------
    Public Const DIR_A_OUTPUT As Integer = &H0
    Public Const DIR_A_INPUT As Integer = &H1
    Public Const DIR_B_OUTPUT As Integer = &H0
    Public Const DIR_B_INPUT As Integer = &H2
    Public Const DIR_C_OUTPUT As Integer = &H0
    Public Const DIR_C_INPUT As Integer = &H4
    Public Const DIR_D_OUTPUT As Integer = &H0
    Public Const DIR_D_INPUT As Integer = &H8
    Public Const DIR_E_OUTPUT As Integer = &H0
    Public Const DIR_E_INPUT As Integer = &H10
    Public Const DIR_F_OUTPUT As Integer = &H0
    Public Const DIR_F_INPUT As Integer = &H20
    '-------------------------------------
    ' ̑萔
    '-------------------------------------
    Public Const MAX_SLOTS As Integer = 16              ' T|[g{[h
    Public Const MAX_PORTS As Integer = 2               ' ANZX\ȃ|[g
    Public Const SLOT_AUTO As Short = &HFFFFS           '
    '-------------------------------------
    ' ؿ\
    '-------------------------------------
    Public Const MIN_NUM As Integer = 0
    Public Const MAX_MEM As Integer = 9 - 1
    Public Const MAX_IO As Integer = 20 - 1
    Public Const MAX_IRQ As Integer = 7 - 1
    Public Const MAX_DMA As Integer = 7 - 1
    Public Const MAX_RSV As Integer = 3 - 1

    Structure Resource
        Dim dwNumMemWindows As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemBase() As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemLength() As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemAttrib() As Integer
        Dim dwNumIOPorts As Integer
        <VBFixedArray(MAX_IO), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IO + 1)> Dim dwIOPortBase() As Integer
        <VBFixedArray(MAX_IO), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IO + 1)> Dim dwIOPortLength() As Integer
        Dim dwNumIRQs As Integer
        <VBFixedArray(MAX_IRQ), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IRQ + 1)> Dim dwIRQRegisters() As Integer
        <VBFixedArray(MAX_IRQ), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IRQ + 1)> Dim dwIRQAttrib() As Integer
        Dim dwNumDMAs As Integer
        <VBFixedArray(MAX_DMA), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_DMA + 1)> Dim dwDMALst() As Integer
        <VBFixedArray(MAX_DMA), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_DMA + 1)> Dim dwDMAAttrib() As Integer
        <VBFixedArray(MAX_RSV), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_RSV + 1)> Dim dwReserved1() As Integer
    End Structure

    '-------------------------------------
    ' J֐
    '-------------------------------------
    <DllImport("apci54.dll")> _
    Public Shared Function Apci54GetVersion(ByRef pdwDllVersion As Integer, ByRef pdwDriverVersion As Integer) As Boolean
    End Function
    <DllImport("apci54.dll")> _
    Public Shared Function Apci54Create(ByRef pwLogSlot As Short) As Boolean
    End Function
    <DllImport("apci54.dll")> _
    Public Shared Function Apci54Close(ByVal wLogSlot As Short) As Boolean
    End Function
    <DllImport("apci54.dll")> _
    Public Shared Function Apci54GetResource(ByVal wLogSlot As Short, ByRef pres As Resource) As Boolean
    End Function
    <DllImport("apci54.dll")> _
    Public Shared Function Apci54GetSwitchValue(ByVal wLogSlot As Short, ByRef pdwSwitchValue As Integer) As Boolean
    End Function
    <DllImport("apci54.dll")> _
    Public Shared Function Apci54GetDirections(ByVal wLogSlot As Short, ByRef pdwDirections As Integer) As Boolean
    End Function
    <DllImport("apci54.dll")> _
    Public Shared Function Apci54SetDirections(ByVal wLogSlot As short, ByVal dwDirections As Integer) As Boolean
    End Function
    <DllImport("apci54.dll")> _
    Public Shared Function Apci54InPort(ByVal wLogSlot As Short, ByVal dwLogPort As Integer, ByRef pbInValue As Byte) As Boolean
    End Function
    <DllImport("apci54.dll")> _
    Public Shared Function Apci54OutPort(ByVal wLogSlot As Short, ByVal dwLogPort As Integer, ByVal bOutValue As Byte) As Boolean
    End Function
    <DllImport("apci54.dll")> _
    Public Shared Function Apci54GetLastError(ByVal wLogSlot As Short) As Integer
    End Function

    '============================================================================
    '     aPCI-P54 DLL,޲ײްްޮݔԍ擾
    '     pdwDllVersion    DLLްޮݔԍi[
    '         pdwDriverVersion ޲ײްްޮݔԍi[
    '  ߂l  True
    '         s False
    '============================================================================
    Public Function GetVersion(ByRef pdwDllVersion As Integer, ByRef pdwDriverVersion As Integer) As Boolean
        Try
            GetVersion = Apci54GetVersion(pdwDllVersion, pdwDriverVersion)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P54 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetVersion = False
        End Try
    End Function
    '============================================================================
    '     aPCI-P54̔Cӂ޲̎gp錾
    '     pwLogSlot  gp޲̘_ۯĔԍi[
    '  ߂l  True
    '         s False
    '============================================================================
    Public Function Create(ByRef pwLogSlot As Short) As Boolean
        Try
            Create = Apci54Create(pwLogSlot)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P54 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Create = False
        End Try
    End Function
    '============================================================================
    '     aPCI-P54̔Cӂ޲̎gpJ
    '     wLogSlot ޲̘_ۯĔԍ
    '  ߂l  True
    '         s False
    '============================================================================
    Public Function Close(ByVal wLogSlot As Short) As Boolean
        Try
            Close = Apci54Close(wLogSlot)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P54 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Close = False
        End Try
    End Function
    '============================================================================
    '     w޲ؿ擾
    '     wLogSlot ؿ擾޲̘_ۯĔԍ
    '         pResInfo ؿi[\
    '  ߂l  True
    '         s False
    '============================================================================
    Public Function GetResource(ByVal wLogSlot As Short, ByRef pResInfo As Resource) As Boolean
        Try
            GetResource = Apci54GetResource(wLogSlot, pResInfo)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P54 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetResource = False
        End Try
    End Function
    '============================================================================
    '     ۰ذ̒l擾
    '     wLogSlot       ۰ذ̒l擾޲̘_ۯĔԍ
    '         pdwSwitchValue ۰ذ̒li[
    '  ߂l  True
    '         s False
    '============================================================================
    Public Function GetSwitchValue(ByVal wLogSlot As Short, ByRef pdwSwitchValue As Integer) As Boolean
        Try
            GetSwitchValue = Apci54GetSwitchValue(wLogSlot, pdwSwitchValue)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P54 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetSwitchValue = False
        End Try
    End Function
    '============================================================================
    '     ިڸ݂̏Ԃ擾
    '     wLogSlot      ިڸݏ擾޲̘_ۯĔԍ
    '         pdwDirections Ԃi[
    '  ߂l  True
    '         s False
    '============================================================================
    Public Function GetDirections(ByVal wLogSlot As Short, ByRef pdwDirections As Integer) As Boolean
        Try
            GetDirections = Apci54GetDirections(wLogSlot, pdwDirections)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P54 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetDirections = False
        End Try
    End Function
    '============================================================================
    '     ިڸ݂
    '     wLogSlot     ިڸݏݒ肷޲̘_ۯĔԍ
    '         dwDirections Ăe
    '  ߂l  True
    '         s False
    '============================================================================
    Public Function SetDirections(ByVal wLogSlot As Short, ByVal dwDirections As Integer) As Boolean
        Try
            SetDirections = Apci54SetDirections(wLogSlot, dwDirections)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P54 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            SetDirections = False
        End Try
    End Function
    '============================================================================
    '     Cӂ߰Ăް
    '     wLogSlot  ͂޲̘_ۯĔԍ
    '         dwLogPort ͂_߰
    '         pbInValue ްi[
    '  ߂l  True
    '         s False
    '============================================================================
    Public Function InPort(ByVal wLogSlot As Short, ByVal dwLogPort As Integer, ByRef pbInValue As Byte) As Boolean
        Try
            InPort = Apci54InPort(wLogSlot, dwLogPort, pbInValue)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P54 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            InPort = False
        End Try
    End Function
    '============================================================================
    '     Cӂ߰Ăްo
    '     wLogSlot  o͂޲̘_ۯĔԍ
    '         dwLogPort o͂_߰
    '         bOutValue o͂ް
    '  ߂l  True
    '         s False
    '============================================================================
    Public Function OutPort(ByVal wLogSlot As Short, ByVal dwLogPort As Integer, ByVal bOutValue As Byte) As Boolean
        Try
            OutPort = Apci54OutPort(wLogSlot, dwLogPort, bOutValue)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P54 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            OutPort = False
        End Try
    End Function
    '============================================================================
    '     aPCI-P54̴װ
    '     wLogSlot  װ޲̘_ۯĔԍ
    '  ߂l װ
    '============================================================================
    Public Function GetLastError(ByVal wLogSlot As Short) As Integer
        Try
            If mErrWradll = ERR_WRAPDLL Then    ' bp[֐G[Ȃ
                mErrWradll = SUCCESS            ' NA
                GetLastError = ERR_WRAPDLL
            Else
                GetLastError = Apci54GetLastError(wLogSlot)
            End If
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-P54 Error")
            GetLastError = ERR_WRAPDLL
            mErrWradll = SUCCESS            ' NA
        End Try
    End Function

End Class
